#pragma once
#include <vector>
#include <benchmarks/bit_stream.h>
#include "wah_bit_vector.h"

namespace aidbms::compression {
    class WAHCompression
    {
    public:
        std::vector<WAHBitVector> compress(aidbms::benchmarks::BitStream &bit_stream);
        aidbms::benchmarks::BitStream decompress(std::vector<WAHBitVector> &compressed);
        void output_file(aidbms::benchmarks::BitStream &bitstream, const std::string filename);
        void output_file(std::vector<WAHBitVector> &bitstream_vector, const std::string filename);
    private:
        bool is_stream_compressible(aidbms::benchmarks::BitStream &bit_stream, const std::size_t index) const;
    };
}
